package kr.pe.theeye.widget;

import java.util.Date;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.widget.RemoteViews;
import android.widget.Toast;


/**
 *  ¸ ֱ ϴ 
 * 
 * @author Eye
 * @since 2011.04.01
 */
public class HelloWidgetProvider extends AppWidgetProvider
{
	private static final String TAG = "HelloWidgetProvider";
	private static final int WIDGET_UPDATE_INTERVAL = 5000;
	private static PendingIntent mSender;
	private static AlarmManager mManager;
	
	/* (non-Javadoc)
	 * @see android.appwidget.AppWidgetProvider#onReceive(android.content.Context, android.content.Intent)
	 */
	@Override
	public void onReceive(Context context, Intent intent)
	{
		super.onReceive(context, intent);
		
		String action = intent.getAction();
		//  Ʈ Ʈ  
		if(action.equals("android.appwidget.action.APPWIDGET_UPDATE"))
		{
			Log.w(TAG, "android.appwidget.action.APPWIDGET_UPDATE");
			removePreviousAlarm();
			
			long firstTime = System.currentTimeMillis() + WIDGET_UPDATE_INTERVAL;
			mSender = PendingIntent.getBroadcast(context, 0, intent, 0);
			mManager = (AlarmManager) context.getSystemService(Context.ALARM_SERVICE);
			mManager.set(AlarmManager.RTC, firstTime, mSender);
		}
		//   Ʈ  
		else if(action.equals("android.appwidget.action.APPWIDGET_DISABLED"))
		{
			Log.w(TAG, "android.appwidget.action.APPWIDGET_DISABLED");
			removePreviousAlarm();
		}
	}

	/* (non-Javadoc)
	 * @see android.appwidget.AppWidgetProvider#onUpdate(android.content.Context, android.appwidget.AppWidgetManager, int[])
	 */
	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds)
	{
		//  Ŭ ϵ   Ʈ 
		appWidgetIds = appWidgetManager.getAppWidgetIds(new ComponentName(context, getClass()));
		super.onUpdate(context, appWidgetManager, appWidgetIds);

		final int N = appWidgetIds.length;
		for(int i = 0 ; i < N ; i++)
		{
			int appWidgetId = appWidgetIds[i];
			updateAppWidget(context, appWidgetManager, appWidgetId);

			Toast.makeText(context, "onUpdate(): [" + String.valueOf(i) + "] " + String.valueOf(appWidgetId), Toast.LENGTH_SHORT).show();
		}
	}

	/**
	 *  ¸ Ʈմϴ.
	 * 
	 * @param context ؽƮ
	 * @param appWidgetManager  ޴
	 * @param appWidgetId Ʈ  ̵
	 */
	public static void updateAppWidget(Context context, AppWidgetManager appWidgetManager, int appWidgetId)
	{
		Date now = new Date();
		RemoteViews updateViews = new RemoteViews(context.getPackageName(), R.layout.hellowidget_layout);
		updateViews.setTextViewText(R.id.widgettext, "[" + String.valueOf(appWidgetId) + "]" + now.toLocaleString());
		appWidgetManager.updateAppWidget(appWidgetId, updateViews);
	}
	
	/**
	 * Ǿִ ˶ մϴ.
	 */
	public void removePreviousAlarm()
	{
		if(mManager != null && mSender != null)
		{
			mSender.cancel();
			mManager.cancel(mSender);
		}
	}
}
